﻿namespace Brizco.Repository.Handlers.Activity;

public class GetShiftPlanActivitiesQueryHandler : IRequestHandler<GetShiftPlanActivitiesQuery, List<ActivitySDto>>
{
    private IRepositoryWrapper _repositoryWrapper;
    public GetShiftPlanActivitiesQueryHandler(IRepositoryWrapper repositoryWrapper)
    {
        _repositoryWrapper = repositoryWrapper;
    }

    public async Task<List<ActivitySDto>> Handle(GetShiftPlanActivitiesQuery request, CancellationToken cancellationToken)
    {
        var activities = await _repositoryWrapper.SetRepository<Domain.Entities.Task.Activity>()
            .TableNoTracking
            .Where(a => a.ShiftPlanId == request.ShiftPlanId)
            .Select(ActivityMapper.ProjectToSDto)
            .ToListAsync(cancellationToken);

        return activities;
    }
}